/*
	TaltOS header
	on the Philips Chip LPC2106

	General Public Licence
	By Peter Eordegh
*/


//Clear the tasklist
void TaltOS_clear_tasklist_clear();

//Clear the input buffer
void TaltOS_clear_input_buffer();

//Clear the flash operation buffer
void TaltOS_clear_flash_op_buffer();

//Clear the environement variables of the TalOS
void TaltOS_clear_environement();

//The TaltOS initialization routine
void TaltOS_init();

//The TaltOS main loop
void TaltOS_loop();

//The TaltOS tic routine for the preemtive task change
void TaltOS_tic();

//The input buffer's input function, can be called by the microcontroller
void TaltOS_char_input_write(unsigned char inchar);

//The input buffer's output function, can be called by the tasks to recive data from out of the system
int TaltOS_char_input_read(unsigned char* ret);

//The output buffer's input function, can be called by the tasks to send data out of system
void TaltOS_char_output_write(unsigned char inchar);

//The output buffer's output function, can be called by the microcontroller
int TaltOS_char_output_read(unsigned char* ret);

//Get the component's address by it's ID (Absolute address)
unsigned long* TaltOS_get_component_address(unsigned long id1, unsigned long id2);

//Get the component's n. function's pointer (Absolute address)
unsigned long TaltOS_get_component_function(unsigned long* address, unsigned long index);

//Run all the components' init function (needed after a reset)
void TaltOS_run_components_init();

//Check if a component has arrived into the input buffer
unsigned int TaltOS_component_arrived();

//Checks if the component's ids are garbage (wrong value => error in erase operation)
unsigned int TaltOS_is_garbage_reg(char *test_array);
